<template>
  <div
    v-if="volume || sum"
    class="info-bar"
  >
    <div
      v-if="volume"
      class="info-bar__block"
    >
      Распределено объемов по всем лотам: {{ volume }}
    </div>

    <div class="info-bar__block text-bold">
      Итоговая сумма затрат по всем лотам:

      <template v-if="sum">
        {{ sum | currency() }} <span class="-gray-slate">₽</span>
      </template>

      <template v-else>—</template>
    </div>
  </div>
</template>

<script>
  export default {
    name: 'infoBar',
    props: {
      source: {
        type: Array,
        required: true
      }
    },
    data () {
      return {
        volume: null,
        sum: null
      }
    },
    watch: {
      source: {
        handler () {
          const roundNumber = (number) => {
            return parseFloat(number.toFixed(2).replace(/\.00$/, ''))
          }

          if (!this.volume) {
            const itemsQuote = this.source.reduce((sum, item) => sum += Number(item.carrierCarriageQuote), 0)
            const itemsPercentage = this.source.reduce((sum, item) => sum += item.percentInTotalVolume, 0)

            const totalQuote = parseInt((itemsQuote / itemsPercentage * 100).toFixed())
            const acceptedCount = this.source.reduce((sum, item) => sum += totalQuote * (item.percentInTotalVolume / 100), 0).toFixed()

            if (totalQuote && acceptedCount) {
              this.volume = `${acceptedCount} из ${totalQuote} (${roundNumber(itemsPercentage)}%)`
            }
          }

          if (!this.sum) {
            this.sum = this.source.reduce((sum, item) => roundNumber(sum += item.cost), 0)
          }
        },
        immediate: true
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .info-bar {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    display: flex;
    justify-content: flex-end;
    background-color: $light-lavender;
    padding: 11px 20px;
    border-top: 1px solid $lavender;

    &__block {
      &:not(:last-child) {
        margin-right: 40px;
      }

      &.text-bold {
        font-weight: bold;
      }
    }
  }
</style>